rawset(_G, "Flimp_MainThinker", function(p)
	if p.mo.skin ~= "flimp" then
		p.mo.flimp_headbutting = nil
		p.mo.flimp_diving = nil
		p.mo.flimp_flying = nil
		p.mo.flimp_flight = nil
		p.mo.flimp_didflying = nil
		p.mo.flimp_diddive = nil
		p.mo.flimp_nodive = nil
		p.mo.flimp_squish = nil

		if p.mo.flimp_duckdance then
			p.mo.state = S_PLAY_STND
			p.mo.flimp_duckdance = nil
			P_RestoreMusic(p)
		end

		return
	end

	if p.playerstate == PST_DEAD then return end

	-- Reset everything
	if P_PlayerInPain(p) or p.playerstate == PST_DEAD or (p.powers[pw_carry] == CR_GENERIC or p.powers[pw_carry] == CR_PLAYER or p.powers[pw_carry] == CR_ROPEHANG or p.powers[pw_carry] == CR_MINECART) then
		p.mo.flimp_headbutting = nil
		p.mo.flimp_diving = nil
		p.mo.flimp_flying = nil
		p.mo.flimp_flight = nil
		p.mo.flimp_didflying = nil
		p.mo.flimp_diddive = nil
		p.mo.flimp_nodive = nil
		p.mo.flimp_squish = nil
		p.mo.flimp_duckdance = nil
		p.mo.spritexscale = FRACUNIT
		p.mo.spriteyscale = FRACUNIT
		p.pflags = $ & ~PF_CANCARRY

		if (p.powers[pw_carry] == CR_GENERIC or p.powers[pw_carry] == CR_PLAYER or p.powers[pw_carry] == CR_ROPEHANG) and p.mo.buttons.jump == 1 then
			P_SetObjectMomZ(p.mo, 5*FRACUNIT, true)
			p.powers[pw_carry] = 0
		end

		return
	end
	
	-- Flimp has less gravity.
	if p.powers[pw_carry] ~= CR_NIGHTSMODE then
		if not P_IsObjectOnGround(p.mo) then
			P_SetObjectMomZ(p.mo, (gravity/6), true)
			p.mo.flimp_didsquish = nil
		else
			p.mo.flimp_flight = nil
			p.mo.flimp_headbutting = nil
			p.mo.flimp_didflying = nil
			p.mo.flimp_nodive = nil

			if p.mo.flimp_diving then
				p.mo.flimp_squish = 25
				p.mo.flimp_sliding = p.mo.flimp_diving
				p.mo.flimp_diving = nil
				p.mo.flimp_didsquish = true
				S_StartSound(p.mo, sfx_dogtoy)
			elseif not p.mo.flimp_didsquish then
				p.mo.flimp_squish = 5
				p.mo.flimp_didsquish = true
				S_StartSound(p.mo, sfx_dogtoy)
			end
		end
	else
		if not p.mo.flimp_squish and P_IsObjectOnGround(p.mo) or (p.mo.z + p.mo.height) >= p.mo.ceilingz then
			p.mo.flimp_squish = 5
			S_StartSound(p.mo, sfx_dogtoy)
		end
	end

	-- Squish Animation
	if p.mo.flimp_squish then
		p.mo.spritexscale = FRACUNIT + (p.mo.flimp_squish*FRACUNIT/25)
		p.mo.spriteyscale = FRACUNIT - (p.mo.flimp_squish*FRACUNIT/25)

		p.mo.flimp_squish = $-1
		if p.mo.flimp_squish <= 0 or not P_IsObjectOnGround(p.mo) then
			p.mo.flimp_squish = nil
			p.mo.spritexscale = FRACUNIT
			p.mo.spriteyscale = FRACUNIT
		end
	end

	-- Spring Flag
	if p.mo.flimp_autospringremove then
		p.mo.flimp_autospringremove = $-1
		if p.mo.flimp_autospringremove <= 0 then
			p.powers[pw_strong] = $ & ~STR_SPRING
			p.mo.flimp_autospringremove = nil
		end
	end

	-- Super Animation
	if p.powers[pw_super] or p.powers[pw_carry] == CR_NIGHTSMODE then
		local spriteframe = max(0, min(2, (leveltime%6)/2))

		local spark
		if not p.mo.flimp_originalaura or not p.mo.flimp_originalaura.valid then
			spark = P_SpawnMobjFromMobj(p.mo, cos(R_PointToAngle(p.mo.x, p.mo.y)), sin(R_PointToAngle(p.mo.x, p.mo.y)), 0, MT_DUMMYOBJ)
			spark.momx = p.mo.momx
			spark.momy = p.mo.momy
			spark.momz = p.mo.momz
			spark.flags = $|MF_NOCLIPHEIGHT
			spark.sprite = SPR_SUPF
			spark.frame = FF_FULLBRIGHT|FF_TRANS80|spriteframe
			spark.blendmode = AST_ADD
			spark.color = p.mo.color
			spark.colorized = true
			spark.fuse = 5

			p.mo.flimp_originalaura = spark
		else
			spark = p.mo.flimp_originalaura

			P_MoveOrigin(p.mo.flimp_originalaura, p.mo.x + cos(R_PointToAngle(p.mo.x, p.mo.y)), p.mo.y + sin(R_PointToAngle(p.mo.x, p.mo.y)), p.mo.z)
			spark.momx = p.mo.momx
			spark.momy = p.mo.momy
			spark.momz = p.mo.momz
			spark.frame = FF_FULLBRIGHT|FF_TRANS80|spriteframe
			spark.scale = p.mo.scale
			spark.color = p.mo.color
			spark.fuse = 5
		end

		if not p.mo.flimp_superauras then p.mo.flimp_superauras = {} end

		for i = 11, 13 do
			if not p.mo.flimp_superauras[i] or not p.mo.flimp_superauras[i].valid then
				spark = P_SpawnMobjFromMobj(p.mo, cos(R_PointToAngle(p.mo.x, p.mo.y)), sin(R_PointToAngle(p.mo.x, p.mo.y)), 0, MT_DUMMYOBJ)
				spark.flags = $|MF_NOCLIPHEIGHT
				spark.momx = p.mo.momx
				spark.momy = p.mo.momy
				spark.momz = p.mo.momz
				spark.sprite = SPR_SUPF
				spark.frame = FF_FULLBRIGHT|FF_TRANS90|spriteframe
				spark.scale = (p.mo.scale/10)*i
				spark.blendmode = AST_ADD
				spark.color = p.mo.color
				spark.colorized = true
				spark.fuse = 5

				p.mo.flimp_superauras[i] = spark
			else
				spark = p.mo.flimp_superauras[i]

				P_MoveOrigin(spark, p.mo.x + cos(R_PointToAngle(p.mo.x, p.mo.y)), p.mo.y + sin(R_PointToAngle(p.mo.x, p.mo.y)), p.mo.z)
				spark.frame = FF_FULLBRIGHT|FF_TRANS90|spriteframe
				spark.scale = (p.mo.scale/10)*i
				spark.color = p.mo.color
				spark.fuse = 5
				spark.momx = p.mo.momx
				spark.momy = p.mo.momy
				spark.momz = p.mo.momz
			end
		end

		if not (leveltime%5) then
			spark = P_SpawnMobjFromMobj(p.mo, P_RandomRange(-50, 50)*FRACUNIT, P_RandomRange(-50, 50)*FRACUNIT, P_RandomRange(-50, 50)*FRACUNIT, MT_BOXSPARKLE)
			spark.scale = 2*FRACUNIT
			spark.destscale = 1
			spark.color = p.mo.color
			spark.colorized = true
			spark.fuse = 20
		end
	end

	if p.powers[pw_carry] == CR_NIGHTSMODE then return end

	-- Headbutt
	if p.mo.flimp_headbutt_anim then
		p.mo.flimp_headbutt_anim = $-1
		if p.mo.flimp_headbutt_anim <= 0 then p.mo.flimp_headbutt_anim = nil end

		if not (leveltime%9) then
			local j = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_DUMMYOBJ)
			j.sprite = SPR_BLBS
			j.frame = FF_FULLBRIGHT|FF_TRANS50|FF_PAPERSPRITE|A
			j.fuse = TICRATE
			j.scale = p.mo.scale
			j.destscale = 5*p.mo.scale
			j.angle = p.drawangle+ANGLE_90
		end
	end

	-- Flight
	if (p.cmd.buttons & BT_JUMP) and not p.nightstime and ((not p.mo.flimp_flight or p.mo.flimp_flight <= 40) or p.powers[pw_super]) and not p.mo.flimp_diving and not P_PlayerInPain(p) and not p.exiting then
		p.mo.flimp_flying = true
	end

	if p.mo.flimp_didflying then
		p.pflags = $|PF_CANCARRY
	end

	if p.mo.flimp_flying then
		local spd = 2*FRACUNIT
		if abs(p.mo.momz) <= 0 then spd = $*3 end
		if ((p.mo.flags2 & MF2_OBJECTFLIP) and p.mo.momz >= -15*FRACUNIT) or ((not (p.mo.flags2 & MF2_OBJECTFLIP)) and p.mo.momz <= 15*FRACUNIT) then P_SetObjectMomZ(p.mo, (p.mo.eflags & MFE_UNDERWATER) and spd/3 or spd, true) end

		if not S_SoundPlaying(p.mo, sfx_s3ka6) then S_StartSound(p.mo, sfx_s3ka6) end
		p.mo.flimp_flight = $ and $+1 or 1
		p.mo.flimp_headbutting = nil
		p.mo.flimp_flying = true
		p.mo.flimp_didflying = true
		p.mo.state = S_PLAY_FLY

		if p.mo.flimp_flight >= 40 and not p.powers[pw_super] then
			S_StartSound(p.mo, sfx_s3kbb)
			S_StartSound(p.mo, sfx_kc44)
			p.mo.state = S_PLAY_FALL
			p.mo.flimp_flying = nil
		elseif not (p.cmd.buttons & BT_JUMP) then
			S_StartSound(p.mo, sfx_s3kbb)
			p.mo.state = S_PLAY_FALL
			p.mo.flimp_flying = nil
		end
	end

	-- Headbutt
	if p.mo.flimp_headbutting and not srb2p then
		p.drawangle = p.mo.flimp_headbutting
		p.powers[pw_strong] = $|STR_SPRING
		p.mo.flimp_autospringremove = 5
		tornadoBust(p)

		p.mo.flimp_headbutt_timer = $ and $+1 or 1

/*
		if p.mo.flimp_headbutt_timer <= 5 and p.mo.buttons.jump == 1 then
			P_Thrust(p.mo, p.drawangle, p.speed <= 5*FRACUNIT and 25*FRACUNIT or 10*FRACUNIT)
			P_SetObjectMomZ(p.mo, -10*FRACUNIT, true)
			S_StartSound(p.mo, sfx_s3ka0)
			p.mo.flimp_flying = nil
			p.mo.flimp_diving = p.mo.angle
			p.pflags = $|PF_SHIELDABILITY
			p.mo.flimp_headbutt_timer = nil
			p.mo.flimp_headbutting = nil
			p.mo.flimp_headbutt_anim = 1
		end
*/

		if p.powers[pw_pushing] then
			S_StartSound(p.mo, sfx_pstop)
			P_InstaThrust(p.mo, p.mo.flimp_headbutting, -10*FRACUNIT)
			P_SetObjectMomZ(p.mo, 7*FRACUNIT)

			p.mo.flimp_headbutting = nil
			p.mo.flimp_headbutt_anim = 1
		end
	end

	if P_IsObjectOnGround(p.mo) and not p.mo.flimp_headbutting and p.mo.buttons.spin == 1 and not P_PlayerInPain(p) and not p.exiting and not srb2p then
		S_StartSound(p.mo, sfx_s3ka2)
		P_Thrust(p.mo, p.drawangle, p.speed <= 5*FRACUNIT and 40*FRACUNIT or 20*FRACUNIT)
		P_SetObjectMomZ(p.mo, 8*FRACUNIT, true)
		p.mo.flimp_headbutting = p.drawangle
		p.mo.flimp_headbutt_anim = 35
		p.mo.flimp_headbutt_timer = 1
		p.mo.state = S_PLAY_FLY
	end

	-- Dive
	if not P_IsObjectOnGround(p.mo) and not p.mo.flimp_headbutting and not p.mo.flimp_diving and p.mo.buttons.spin == 1 and not P_PlayerInPain(p) and not p.exiting and not srb2p and not p.mo.flimp_nodive then
		if All7Emeralds(emeralds) and (p.rings >= 50) and (p.powers[pw_shield] == SH_NONE) and not p.powers[pw_super] then
			P_DoSuperTransformation(p)
		else
			if p.powers[pw_super] then
				P_Thrust(p.mo, p.drawangle, 40*FRACUNIT)
				S_StartSound(p.mo, sfx_s3ka0)
				p.mo.flimp_flying = nil
				p.mo.flimp_diving = p.mo.angle
			else
				P_Thrust(p.mo, p.drawangle, p.speed <= 5*FRACUNIT and 25*FRACUNIT or 10*FRACUNIT)
				P_SetObjectMomZ(p.mo, -10*FRACUNIT, true)
				S_StartSound(p.mo, sfx_s3ka0)
				p.mo.flimp_flying = nil
				p.mo.flimp_diving = p.mo.angle
				p.pflags = $|PF_SHIELDABILITY
			end
		end
	end

	if p.mo.flimp_diving and not srb2p then
		if p.powers[pw_super] then
			p.powers[pw_strong] = $|STR_SPRING
			p.mo.flimp_autospringremove = 5

			p.drawangle = p.mo.flimp_diving
			p.mo.flimp_headbutt_anim = 35
			P_Thrust(p.mo, p.mo.flimp_diving, 5*FRACUNIT)
			P_SetObjectMomZ(p.mo, 0)
			p.powers[pw_nocontrol] = 32773

			if (p.cmd.buttons & BT_JUMP) and not p.nightstime and ((not p.mo.flimp_flight or p.mo.flimp_flight <= 40) or p.powers[pw_super]) and not p.mo.flimp_diving and not P_PlayerInPain(p) and not p.exiting then
				p.mo.flimp_flying = true
				p.mo.flimp_headbutt_anim = 1
				p.mo.flimp_diving = nil
			end

			if p.powers[pw_pushing] then
				S_StartSound(p.mo, sfx_pstop)
				P_InstaThrust(p.mo, p.mo.flimp_diving, -10*FRACUNIT)
				P_SetObjectMomZ(p.mo, 7*FRACUNIT)
				p.powers[pw_nocontrol] = 0
				p.mo.flimp_headbutt_anim = 1
				p.mo.flimp_diving = nil
				p.mo.buttons.spin = 0
			end
		else
			p.powers[pw_strong] = $|STR_SPRING
			p.mo.flimp_autospringremove = 5
			tornadoBust(p)

			p.drawangle = p.mo.flimp_diving
			P_Thrust(p.mo, p.mo.flimp_diving, FRACUNIT/2)
			P_SetObjectMomZ(p.mo, -2*FRACUNIT, true)

			if (p.cmd.buttons & BT_JUMP) and not p.nightstime and not P_PlayerInPain(p) and not p.exiting then
				S_StartSound(p.mo, sfx_s3ka2)
				P_Thrust(p.mo, p.mo.angle, p.speed <= 5*FRACUNIT and 40*FRACUNIT or 20*FRACUNIT)
				P_SetObjectMomZ(p.mo, 4*FRACUNIT)
				p.mo.flimp_headbutting = p.mo.angle
				p.mo.flimp_headbutt_anim = 35
				p.mo.flimp_headbutt_timer = 1
				p.mo.flimp_diving = nil
				p.mo.flimp_nodive = true
				p.mo.state = S_PLAY_FLY
			end

			if (p.mo.eflags & MFE_GOOWATER) then
				p.mo.spritexscale = FRACUNIT
				p.mo.spriteyscale = FRACUNIT
				S_StartSound(p.mo, sfx_s3k49)
				P_SetObjectMomZ(p.mo, -20*FRACUNIT, true)

				local goop
				for i = 1, 16 do
					goop = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_SPINDUST)
					P_InstaThrust(goop, i*ANGLE_22h, 18*FRACUNIT)
	--				P_SetObjectMomZ(goop, 10*FRACUNIT)

					goop.color = SKINCOLOR_LAVENDER
					goop.colorized = true
				end

				p.mo.flimp_diving = nil
				p.pflags = $ & ~PF_SHIELDABILITY
			end
		end
	end

	-- Sliding 
	if p.mo.flimp_sliding and not srb2p then
		p.drawangle = p.mo.flimp_sliding
		p.pflags = $|PF_SPINNING
		if not S_SoundPlaying(p.mo, sfx_s3k7e) then S_StartSound(p.mo, sfx_s3k7e) end
		p.mo.state = S_PLAY_FALL

		if (not P_IsObjectOnGround(p.mo)) or P_PlayerInPain(p) or p.playerstate == PST_DEAD or p.speed <= 5*FRACUNIT or p.mo.flimp_headbutting then
			p.mo.flimp_sliding = nil
			p.mo.state = P_IsObjectOnGround(p.mo) and S_PLAY_STND or S_PLAY_FALL
			p.pflags = $ & ~PF_SPINNING
		end

		if not p.mo.flimp_squish then p.mo.flimp_squish = 4 end
	end

	-- Duck Dance
	if (p.cmd.buttons & BT_CUSTOM3) and p.speed <= 0 and P_IsObjectOnGround(p.mo) and not p.mo.flimp_duckdance and not p.tanukisuit and not p.mo.blossom_tanukianim then
		p.mo.flimp_duckdance = 1
		P_PlayJingleMusic(p, "HEYYA", nil, true, JT_OTHER)
	end

	if p.mo.flimp_duckdance then
		if p.speed > 0 or not P_IsObjectOnGround(p.mo) then
			p.mo.state = S_PLAY_STND
			p.mo.flimp_duckdance = nil
			P_RestoreMusic(p)
		else
			if p.mo.state ~= S_PLAY_BLOSSOM_DUCKDANCE then p.mo.state = S_PLAY_BLOSSOM_DUCKDANCE end
			if p.mo.blossom_flimp and p.mo.blossom_flimp.valid then p.mo.blossom_flimp.frame = p.mo.frame+1 end
		end
	end
end)